﻿// ©  Copyright IBM Corp. 1998 - 2004 All Rights Reserved
var m_nQTimeoutID;
var m_nQTimeoutTime;
var m_nQTimeoutViewID;
var m_bIncompleteIncorrect;
var m_nQMaxTimeout;

// Begin Question High Level API
function QuestionEvalOption(windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sResult = EvaluateOption("opt",nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget);    
	
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
		if (sResult.toLowerCase() == "final"){
			var sRepResult = "wrong";
		}else{
			var sRepResult = sResult;
		}
		if (sQuestionID != ""){
			if (m_sTracking=="scorm" || m_sTracking=="HACP"){
				if (m_bReportInteraction==true && m_bCacheInteractionData==0){
					lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID)); 
				}
			}
		}	
	}

	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true");
	}        

	if (sResult.toLowerCase() != "final"){
		if (GetOptionFrameNumber("opt",windowtarget) != 0 && (""+GetOptionFrameNumber("opt",windowtarget)) != "undefined"){
			var sPath = GetOptionFrameNumber("opt",windowtarget);
			if (sPath != ""){
				sResult = "specific_" + sPath;
			}
		}
	}
	
	return sResult;
}

function QuestionEvalMultiGroupOption(sGroupPrefix, nNumGroup, sCorrectBulletPrefix, sIncorrectBulletPrefix, sBtnEvaluate, sBtnNext, windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sOptResult = "";
	var sResult = "";
	var bCorrect = true;
	
	if(nNumGroup > 1 && nNumTries > 1) {
		var nNumT = parseInt(nNumTries) * nNumGroup - 1;
	}	else {
		var nNumT = parseInt(nNumTries);
	}

	if(CheckIncompleteAnswers(sGroupPrefix,nNumGroup,windowtarget) == false) {
		return;
	}
	
	for(var i=0; i<nNumGroup; i++) {
		sOptResult = EvaluateOption(sGroupPrefix + eval(i+1),nNumT,sAssessmentID,sQuestionID,sQType,windowtarget);
		if(sOptResult.toLowerCase() != "correct") {
				bCorrect = false;
				sResult = sOptResult;
		} 
	}

	if(bCorrect == true) {
		sResult = "Correct";
	}
		
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
		if (sResult.toLowerCase() == "final"){
			var sRepResult = "wrong";
		}else{
			var sRepResult = sResult;
		}
		if (sQuestionID != ""){
			if (m_sTracking=="scorm" || m_sTracking=="HACP"){
				if (m_bReportInteraction==true && m_bCacheInteractionData==0){
					lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID));
				}
			}
		}	
	}

	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true"); 
	}

	SetQuestionResult(sResult,sCorrectBulletPrefix,sIncorrectBulletPrefix,sBtnEvaluate,sBtnNext,windowtarget);
}

function CheckIncompleteAnswers(sGrpPrefix, nNumOfGroups, windowtarget) {
	var sStudentAns = "";
	
	for(var i=0; i<nNumOfGroups; i++) {
		sStudentAns += GetGroupStudentAns(sGrpPrefix + eval(i+1),"true",windowtarget) + "&";
	}
	sStudentAns = sStudentAns.substring(0,sStudentAns.length-1);
	
	var sStdAnsOpt = sStudentAns.split("&");
	for (var i=0;i<sStdAnsOpt.length;i++)	{
		if (String(sStdAnsOpt[i]).indexOf("true")==-1)	{
			HideLayer("Partial",windowtarget);
			HideLayer("Incorrect",windowtarget);
			HideLayer("Incomplete",windowtarget);
			ShowLayer("Incomplete",windowtarget);
			return false;
		}
	}
	return true;
}

function SetQuestionResult(sResult,sCorrectBulletPrefix,sIncorrectBulletPrefix,sBtnEvaluate,sBtnNext,windowtarget) {
	if(sResult == "Correct") {
		ShowCorrectBullets(sCorrectBulletPrefix,false,windowtarget);
		HideLayer("Partial",windowtarget);
		HideLayer("Incorrect",windowtarget);
		HideLayer("Incomplete",windowtarget);
		ShowLayer(sResult,windowtarget);
		SetVisibility(sBtnEvaluate,"hidden",windowtarget);
		SetButtonState(sBtnNext,"enabled",windowtarget);
		SetDataMultiOption(sResult);
	}
	
	if(sResult == "Incorrect") {
		HideLayer("Partial",windowtarget);
		HideLayer("Incorrect",windowtarget);
		HideLayer("Incomplete",windowtarget);
		ShowLayer(sResult,windowtarget);
	}
	
	if(sResult == "Partial") {
		HideLayer("Incorrect",windowtarget);
		HideLayer("Incomplete",windowtarget);
		ShowLayer("Partial",windowtarget);	
	}	
	
	if(sResult == "Final") {
		ShowCorrectBullets(sCorrectBulletPrefix,false,windowtarget);
		ShowIncorrectBullets(sIncorrectBulletPrefix,false,windowtarget);		
		HideLayer("Partial",windowtarget);
		HideLayer("Incorrect",windowtarget);				
		HideLayer("Incomplete",windowtarget);
		ShowLayer(sResult,windowtarget);
		SetVisibility(sBtnEvaluate,"hidden",windowtarget);
		SetButtonState(sBtnNext,"enabled",windowtarget);		
		SetDataMultiOption(sResult);
	}
}

function QuestionEvalMSIMultiGroupOption(sGroupPrefix, sOptionNamePrefix, sMSINamePrefix, nNumGroup, sCorrectBulletPrefix, sIncorrectBulletPrefix, sBtnEvaluate, sBtnNext, windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sOptResult = "";
	var sResult = "";
	var bCorrect = true;
	var nNumOption = 0;
	
	if(nNumGroup > 1 && nNumTries > 1) {
		var nNumT = parseInt(nNumTries) * nNumGroup - 1;
	}	else {
		var nNumT = parseInt(nNumTries);
	}
	
	if(CheckIncompleteAnswers(sGroupPrefix,nNumGroup,windowtarget) == false) {
		return;
	}	
	
	for(var i=0; i<nNumGroup; i++) {
		sOptResult = EvaluateOption(sGroupPrefix + eval(i+1),nNumT,sAssessmentID,sQuestionID,sQType,windowtarget);
		var arrChk=windowtarget.document.getElementsByName(sGroupPrefix + eval(i+1));
		nNumOption +=arrChk.length;
		
		if(sOptResult.toLowerCase() != "correct") {
			bCorrect = false;
			sResult = sOptResult;
		}
	}
		
	if(bCorrect == true) {
		sResult = "Correct";
	}
		
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
		if (sResult.toLowerCase() == "final"){
			var sRepResult = "wrong";
		}else{
			var sRepResult = sResult;
		}
		if (sQuestionID != ""){
			if (m_sTracking=="scorm" || m_sTracking=="HACP"){
				if (m_bReportInteraction==true && m_bCacheInteractionData==0){
					lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID)); 
				}
			}
		}	
	}

	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true"); 
		SetMSIStateForMultiOption(sOptionNamePrefix,sMSINamePrefix,nNumOption,windowtarget);
	}
	
	SetQuestionResult(sResult,sCorrectBulletPrefix,sIncorrectBulletPrefix,sBtnEvaluate,sBtnNext,windowtarget);
}

function SetDataMultiOption(sLayerName) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	SetEventData(m_lEventID,"sQuestionFeedback",sLayerName);
}

function GetDataMultiOption(sCorrectBulletPrefix, sIncorrectBulletPrefix, sBtnEvaluate, windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling	
	var sLayer = GetEventData(m_lEventID,"sQuestionFeedback");
	
	if(sLayer == "Correct") {
	 ShowCorrectBullets(sCorrectBulletPrefix,false,windowtarget);
	 ShowLayer(sLayer, windowtarget);
	 SetVisibility(sBtnEvaluate,"hidden",windowtarget);		
	}
	
	if(sLayer == "Final") {
	 ShowCorrectBullets(sCorrectBulletPrefix,false,windowtarget);
	 ShowIncorrectBullets(sIncorrectBulletPrefix,false,windowtarget);		
	 ShowLayer(sLayer, windowtarget);
	 SetVisibility(sBtnEvaluate,"hidden",windowtarget);		
	}
}

function SetMSIStateForMultiOption(sOptionPrefix, sMSIPrefix, nNumOpt, windowtarget) {
	for(var i=1;i<=nNumOpt;i++) {
		if(GetCorrectAns(sOptionPrefix+i) == 'True') {
			SetMultistateImageState(sMSIPrefix+String(i),'state 4',windowtarget);
		} else {
			SetMultistateImageState(sMSIPrefix+String(i),'state 3',windowtarget);
		}
	}
}


function SetMSIMultiOption(sMSIName, sMSIPrefix, sOptionPrefix, nStartMSIGroup, nEndMSIGroup, windowtarget) {
	var sLayer = GetEventData(m_lEventID,"sQuestionFeedback");
	if(sLayer == 'Final') {
		return;
	}
	
	for(var i=nStartMSIGroup;i<=nEndMSIGroup;i++) {
		if(sMSIName == sMSIPrefix+String(i)) {
			SetMultistateImageState(sMSIName,'state 2',windowtarget);
			SetOptionChecked(sOptionPrefix+String(i),true,windowtarget);
		} else {
			SetMultistateImageState(sMSIPrefix+String(i),'state 1',windowtarget);
		}
	}
}

function SetMSIOption(sMSIName, sMSIPrefix, sOptionPrefix, nNumOptions, windowtarget) {
	for(var i=1;i<=nNumOptions;i++) {
		if(sMSIName == sMSIPrefix+String(i)) {
			SetMultistateImageState(sMSIName,'state 2',windowtarget);
			SetOptionChecked(sOptionPrefix+String(i),true,windowtarget);
		} else {
			SetMultistateImageState(sMSIPrefix+String(i),'state 1',windowtarget);
		}
	}
}

function SetMSICheckbox(sMSIName, sCheckboxName, windowtarget) {
	var sState = GetMultistateImageState(sMSIName,windowtarget);
	if(sState == 'state 1') {
		SetMultistateImageState(sMSIName,'state 2',windowtarget);
		SetCheckboxChecked(sCheckboxName,true,windowtarget);
	} else {
		SetMultistateImageState(sMSIName,'state 1',windowtarget);
		SetCheckboxChecked(sCheckboxName,false,windowtarget);
	}
}

function QuestionEvalOptionAndJump(windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	lCorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].CORRECTJUMPTO);
	lIncorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCORRECTJUMPTO);
	lFinalFrameID = convertNull(m_arrEvents[String(m_lEventID)].FINALJUMPTO);
	lIncompleteFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCOMPLETEJUMPTO);
	retVal = QuestionEvalOption(windowtarget);
	if (retVal != ""){ 
		if (retVal.substring(0,9).toLowerCase() == "specific_"){
			retVal = retVal.substring(9,retVal.length);
			if (retVal.substring(0,6) == "frame_"){
				retVal = Number(retVal.substring(6,retVal.length));
			}	
		}else{ 
			retVal = eval("l" + retVal + "FrameID");
			if (retVal.substring(0,6) == "frame_"){
				//retVal = "frame" + retVal.substring(6,retVal.length);
				retVal = Number(retVal.substring(6,retVal.length));
			}	
		}			
		if(retVal != "" && retVal != 0){
			var oNavLinkNode = getNavForNavLink(retVal);
	  	    if (oNavLinkNode != null && (""+oNavLinkNode) != "undefined"){
				GotoChildNav(oNavLinkNode.NAME);
			}else{
				GotoFrame(retVal);		
			}
		}else{
			alert("Invalid Path");
		}
	}
}

function EvaluateOption(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	
	var endTime = new Date();
	var qLatency = CalculateLatency();
	endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	
	if (sQType == "likert"){
		sEvalResult="Correct";
	}else{
		sEvalResult=ResultsFromEvaluateOption(sGroupName,windowtarget);
	}		
	
	if ((sEvalResult == "Incorrect") && (m_nNumTries >= nNumTries)){
	    clearInterval(m_nQTimeoutID);
	    m_nQTimeoutID = null;
		sEvalResult = "Final";
		m_arrEvents[String(m_lEventID)].STATE = "F";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var endTime = new Date();
		var qLatency = CalculateLatency();
		endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	}
	
	if(sEvalResult != "Incomplete"){
		m_nNumTries++;  		
	}	
	
	if (sEvalResult == "Correct"){
	  clearInterval(m_nQTimeoutID);
   	m_nQTimeoutID = null;
		m_arrEvents[String(m_lEventID)].STATE = "C";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var endTime = new Date();
		var qLatency = CalculateLatency();
		endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	}	
		
	if ((""+sQuestionID!="undefined") && (""+sAssessmentID!="undefined")){
		if (sQuestionID!=""&&sAssessmentID!=""){
			var sCorrectAns = GetGroupCorrectAns(sGroupName,"true",windowtarget);
			var sStudentAns = GetGroupStudentAns(sGroupName,"true",windowtarget);
			var sOrg_StudentAns = sStudentAns;
			
			for (var i=0;i<sCorrectAns.split("|").length;i++){
				if (sCorrectAns.split("|")[i].toLowerCase() == "true"){
					sCorrectAns = (i + 1);
					break;
				}		
			}	
  		
  		for (var i=0;i<sStudentAns.split("|").length;i++){
				if (sStudentAns.split("|")[i].toLowerCase() == "true"){
					sStudentAns = (i + 1);
					break;
				}		
			}	
  
			if (String(sOrg_StudentAns).indexOf("true")==-1){
			    sStudentAns = "0";
			}
  			
			if (sEvalResult == "Final"){
  				SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT","Incorrect");  
			}else{
				SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT",sEvalResult);  
			}
			
	
			if (sQType == "likert"){
				SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER","");  
			}else{
				SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER",sCorrectAns);  
			}
				
			SetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER",sStudentAns);  
			SetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY",qLatency);  
			SetQuestionProperty(sAssessmentID,sQuestionID,"TIME",endTime);  

  			if ((""+sQType) != "undefined"){
 				SetQuestionProperty(sAssessmentID,sQuestionID,"QTYPE",sQType);
 			}
		}  		  
	}  
	
	return sEvalResult;
}

function QuestionEvalEditbox(windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var sGroupName = "edt";
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sResult = EvaluateEditbox("edt",nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget);
	if (sResult.toLowerCase() == "final" || sResult.toLowerCase() == "correct"){
		if (sQuestionID != ""){
		    if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			    if (sResult.toLowerCase() == "correct"){
			        var sCorrectAns = GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER");
		    	}else{
		        	var sCorrectAns = GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER");
		    	}
		    	if (sResult.toLowerCase() == "final"){
			        var sRepResult = "wrong";
			    }else{
		    	    var sRepResult = sResult;
		    	}
		    	if (m_bReportInteraction==true && m_bCacheInteractionData==0){
		        	lmsSetQuestionData(sQuestionID,sQType,sCorrectAns,GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"), getObjectiveIDForAssessment(sAssessmentID)); 
		    	}
		    }  
		}		    
	}      
	
	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true");
	}        
	
	return sResult;
}


function QuestionEvalEditboxAndJump(windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	lCorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].CORRECTJUMPTO);
	lIncorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCORRECTJUMPTO);
	lFinalFrameID = convertNull(m_arrEvents[String(m_lEventID)].FINALJUMPTO);
	lIncompleteFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCOMPLETEJUMPTO);
	lPartialFrameID = convertNull(m_arrEvents[String(m_lEventID)].PARTIALJUMPTO);

	retVal = QuestionEvalEditbox(windowtarget);
	if (retVal != ""){ 
		var sPath = eval("l" + retVal + "FrameID");
		if (sPath.substring(0,6).toLowerCase() == "frame_"){
			sPath = sPath.substring(6,sPath.length);
    		loadFrame(m_lAliasID,sPath,false);
		}else if(sPath != "" && sPath != 0){
			var oNavLinkNode = getNavForNavLink(sPath);
	  	    if (oNavLinkNode != null && (""+oNavLinkNode) != "undefined"){
				GotoChildNav(oNavLinkNode.NAME);
			}else{
				GotoFrame(sPath);		
			}

		}else{
			alert("Invalid Path");
		}
	}  		
}



function EvaluateEditbox(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var arrEdt=windowtarget.document.getElementsByName(sGroupName);
	var endTime = new Date();
	var qLatency = CalculateLatency();
	endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	var sLength = 0;
	var sEvalResult = "";
	if (sQType == "likert"){
		sEvalResult = "Correct";
	}else{
		sEvalResult = ResultsFromEvaluateEditbox(sGroupName,windowtarget);
	}	
	if (((sEvalResult == "Incorrect")||(sEvalResult == "Partial")) && (m_nNumTries >= nNumTries)){
	    clearInterval(m_nQTimeoutID);
   	    m_nQTimeoutID = null;
		sEvalResult = "Final";
		m_arrEvents[String(m_lEventID)].STATE = "F";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var qLatency = CalculateLatency();
	}else if(sEvalResult == "Partial"){
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
	}
	if(sEvalResult != "Incomplete"){
		m_nNumTries++;  		
	}
	
	if (sEvalResult == "Correct"){
	    clearInterval(m_nQTimeoutID);
   	    m_nQTimeoutID = null;
		m_arrEvents[String(m_lEventID)].STATE = "C";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var endTime = new Date();
		var qLatency = CalculateLatency();
		endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	}
		
	if ((""+sQuestionID!="undefined") && (""+sAssessmentID!="undefined")){
		if (sQuestionID!=""&&sAssessmentID!=""){

			
			if (sEvalResult == "Correct"){ // if correct just send back the student answer for the correct answer
				var aCorrectAns = GetGroupStudentAns(sGroupName,"true",windowtarget);
			}else{	
				var aCorrectAns = GetGroupCorrectAns(sGroupName,"true",windowtarget);	
			}
			var aStudentAns = GetGroupStudentAns(sGroupName,"true",windowtarget);
			var sCorrectAns = "";
			var sStudentAns = "";
			
			if (aCorrectAns.indexOf("|") == -1){
				sCorrectAns = aCorrectAns;
				sStudentAns = aStudentAns;
			}else{
				if (aCorrectAns.split("|").length == 1){
					sCorrectAns = sCorrectAns.split("|")[0];				
					sStudentAns = sStudentAns.split("|")[0];
				}else{
					for (var i=0;i<aCorrectAns.split("|").length;i++){
						sCorrectAns = sCorrectAns + "," + (i+1) + "." +  aCorrectAns.split("|")[i];
					}		
		  			for (var i=0;i<aStudentAns.split("|").length;i++){
		  			    if (aStudentAns.split("|")[i] != ""){
						    sStudentAns = sStudentAns + "," + (i+1) + "." +  aStudentAns.split("|")[i];
						}    
					}		
				}
				
	  			if (sStudentAns == ""){
	  			    for (var i=0;i<aCorrectAns.split("|").length;i++){
					    sStudentAns = sStudentAns + "," + (i+1) + ".0";
					}	
	  			}
	  			if (sStudentAns.charAt(0) == ","){
	  	    		sStudentAns = sStudentAns.substring(1,sStudentAns.length);
	  			}
	  			if (sCorrectAns.charAt(0) == ","){
	  	    		sCorrectAns = sCorrectAns.substring(1,sCorrectAns.length);
	  			}
			}	  			
  			if (sEvalResult == "Final"){
  	    		SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT","Incorrect");  
    		}else{
        		SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT",sEvalResult);  
    		}
    		if (sQType == "likert"){  	      
    			SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER","");  
			}else{
				SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER",sCorrectAns);  
			}    			
    		SetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER",sStudentAns);  
  			SetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY",qLatency);  
  			SetQuestionProperty(sAssessmentID,sQuestionID,"TIME",endTime);
  		
	  		if ((""+sQType) != "undefined"){
 			    SetQuestionProperty(sAssessmentID,sQuestionID,"QTYPE",sQType);
 			}  
    	}  		  
	}  
	return sEvalResult;
}

function QuestionEvalCheckBox(windowtarget, bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sResult = EvaluateCheckBox("chk",nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget,bPartiallyCorrect);
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
	    if (sResult.toLowerCase() == "final"){
	 	   var sRepResult = "wrong";
	    }else{
		    var sRepResult = sResult;
	    }
	    if (sQuestionID != ""){
		    if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			    if (m_bReportInteraction==true && m_bCacheInteractionData==0){
		    	    lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID)); 
		    	}
		    }
		}		    
	}      
	
	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true");
	}        
	
	return sResult;
}


function QuestionEvalMultiGroupCheckBox(sGroupPrefix, nNumGroup, sCorrectBulletPrefix, sIncorrectBulletPrefix, sBtnEvaluate, sBtnNext, windowtarget, bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sOptResult = "";
	var sResult = "";
	var bCorrect = true;
	
	if(nNumGroup > 1 && nNumTries > 1) {
		var nNumT = parseInt(nNumTries) * nNumGroup - 1;
	}	else {
		var nNumT = parseInt(nNumTries);
	}
	
	if(CheckIncompleteAnswers(sGroupPrefix,nNumGroup,windowtarget) == false) {
		return;
	}
	
	for(var i=0; i<nNumGroup; i++) {
		sOptResult = EvaluateCheckBox(sGroupPrefix + eval(i+1),nNumT,sAssessmentID,sQuestionID,sQType,windowtarget,bPartiallyCorrect);
		if(sOptResult.toLowerCase() != "correct") {
				bCorrect = false;
				sResult = sOptResult;
		}
	}

	if(bCorrect == true) {
		sResult = "Correct";
	}	
	
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
	    if (sResult.toLowerCase() == "final"){
	 	   var sRepResult = "wrong";
	    }else{
		    var sRepResult = sResult;
	    }
	    if (sQuestionID != ""){
		    if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			    if (m_bReportInteraction==true && m_bCacheInteractionData==0){
		    	    lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID)); 
		    	}
		    }
		}		    
	}      
	
	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true");
	}        

	SetQuestionResult(sResult,sCorrectBulletPrefix,sIncorrectBulletPrefix,sBtnEvaluate,sBtnNext,windowtarget);
}

function QuestionEvalMSIMultiGroupCheckBox(sGroupPrefix, sOptionNamePrefix, sMSINamePrefix, nNumGroup, sCorrectBulletPrefix, sIncorrectBulletPrefix, sBtnEvaluate, sBtnNext, windowtarget, bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var nNumTries = GetNumOfTries(m_lEventID);
	var sAssessmentID = GetAssessmentID(m_lEventID);
	var sQuestionID = GetQuestionID(m_lEventID);
	var sQType = GetQuestionType(m_lEventID);
	var sOptResult = "";
	var sResult = "";
	var bCorrect = true;
	var nNumOption = 0;
	
	if(nNumGroup > 1 && nNumTries > 1) {
		var nNumT = parseInt(nNumTries) * nNumGroup - 1;
	}	else {
		var nNumT = parseInt(nNumTries);
	}

	if(CheckIncompleteAnswers(sGroupPrefix,nNumGroup,windowtarget) == false) {
		return;
	}
	
	for(var i=0; i<nNumGroup; i++) {
		sOptResult = EvaluateCheckBox(sGroupPrefix + eval(i+1),nNumT,sAssessmentID,sQuestionID,sQType,windowtarget,bPartiallyCorrect);
		if(sOptResult.toLowerCase() != "correct") {
				bCorrect = false;
				sResult = sOptResult;
		}
	}

	if(bCorrect == true) {
		sResult = "Correct";
	}	
	
	if (sResult.toLowerCase() == "final"||sResult.toLowerCase() == "correct"){
	    if (sResult.toLowerCase() == "final"){
	 	   var sRepResult = "wrong";
	    }else{
		    var sRepResult = sResult;
	    }
	    if (sQuestionID != ""){
		    if (m_sTracking=="scorm" || m_sTracking=="HACP"){
			    if (m_bReportInteraction==true && m_bCacheInteractionData==0){
		    	    lmsSetQuestionData(sQuestionID,sQType,GetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER"),GetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER"),sRepResult,GetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY"),GetQuestionProperty(sAssessmentID,sQuestionID,"WEIGHT"),getObjectiveIDForAssessment(sAssessmentID)); 
		    	}
		    }
		}		    
	}      
	
	if (sResult == "Correct" || sResult == "Final") {
		MarkCurrentEventAndChildrenVisited("true");
		SetMSIStateForMultiOption(sOptionNamePrefix,sMSINamePrefix,nNumOption,windowtarget);
	}        

	SetQuestionResult(sResult,sCorrectBulletPrefix,sIncorrectBulletPrefix,sBtnEvaluate,sBtnNext,windowtarget);
}

function QuestionEvalCheckBoxAndJump(windowtarget,bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	lCorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].CORRECTJUMPTO);
	lIncorrectFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCORRECTJUMPTO);
	lFinalFrameID = convertNull(m_arrEvents[String(m_lEventID)].FINALJUMPTO);
	lIncompleteFrameID = convertNull(m_arrEvents[String(m_lEventID)].INCOMPLETEJUMPTO);
	lPartialFrameID = convertNull(m_arrEvents[String(m_lEventID)].PARTIALJUMPTO);
	retVal = QuestionEvalCheckBox(windowtarget,bPartiallyCorrect);
	if (retVal != ""){
	    var sPath = eval("l" + retVal + "FrameID");
	    if (sPath.substring(0,6).toLowerCase() == "frame_"){
		    sPath = sPath.substring(6,sPath.length);
	    	loadFrame(m_lAliasID,sPath,false);
	    }else if(sPath != "" && sPath != 0){
			var oNavLinkNode = getNavForNavLink(sPath);
	  	    if (oNavLinkNode != null && (""+oNavLinkNode) != "undefined"){
				GotoChildNav(oNavLinkNode.NAME);
			}else{
				GotoFrame(sPath);		
			}

	    }else{
	    	alert("Invalid Path");
	    }
	}
}

function EvaluateCheckBox(sGroupName,nNumTries,sAssessmentID,sQuestionID,sQType,windowtarget,bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	var endTime = new Date();
	var qLatency = CalculateLatency();
	endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	var sEvalResult = "";
	if (sQType == "likert"){
		sEvalResult = "Correct";
	}else{
		sEvalResult = ResultsFromEvaluateCheckBox(sGroupName,windowtarget,bPartiallyCorrect);
	}		
	if (((sEvalResult == "Incorrect")||(sEvalResult == "Partial")) && (m_nNumTries >= nNumTries)){
	    clearInterval(m_nQTimeoutID);
   	    m_nQTimeoutID = null;
		sEvalResult = "Final";
		m_arrEvents[String(m_lEventID)].STATE = "F";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var endTime = new Date();
		var qLatency = CalculateLatency();
		endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	}else if(sEvalResult == "Partial"){
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
	}	
	if(sEvalResult != "Incomplete"){
		m_nNumTries++;  		
	}
	if (sEvalResult == "Correct"){
	    clearInterval(m_nQTimeoutID);
   	    m_nQTimeoutID = null;
		m_arrEvents[String(m_lEventID)].STATE = "C";
		m_arrEvents[String(m_lEventID)].FINALGROUP = arrPush(m_arrEvents[String(m_lEventID)].FINALGROUP,sGroupName);
		var endTime = new Date();
		var qLatency = CalculateLatency();
		endTime = endTime.getHours() + ":" + right("00"+parseInt(endTime.getMinutes()),2) + ":" + right("00" +parseInt(endTime.getSeconds()),2);
	}
	if ((""+sQuestionID!="undefined") && (""+sAssessmentID!="undefined")){
		if (sQuestionID!=""&&sAssessmentID!=""){
			
			var aCorrectAns = GetGroupCorrectAns(sGroupName,"true",windowtarget);
			var aStudentAns = GetGroupStudentAns(sGroupName,"true",windowtarget);
			var sCorrectAns = "";
			var sStudentAns = "";
			
			for (var i=0;i<aCorrectAns.split("|").length;i++){
				if (aCorrectAns.split("|")[i].toLowerCase() == "true"){
					sCorrectAns = sCorrectAns + "," + (i + 1);
				}		
			}	
  			for (var i=0;i<aStudentAns.split("|").length;i++){
				if (aStudentAns.split("|")[i].toLowerCase() == "true"){
					sStudentAns = sStudentAns + "," + (i + 1);
				}		
			}
			if (sStudentAns.charAt(0) == ","){
  	    		sStudentAns = sStudentAns.substring(1,sStudentAns.length);
  			}
  			if (sStudentAns == ""){
  			    sStudentAns = 0;
  			}
  			
  			if (sCorrectAns.charAt(0) == ","){
  	    		sCorrectAns = sCorrectAns.substring(1,sCorrectAns.length);
  			}

  			if (sEvalResult == "Final"){
  	    		SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT","Incorrect");  
    		}else{
        		SetQuestionProperty(sAssessmentID,sQuestionID,"RESULT",sEvalResult);  
    		}
    		if (sQType == "likert"){  	      
    			SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER","");  
			}else{
				SetQuestionProperty(sAssessmentID,sQuestionID,"CORRECTANSWER",sCorrectAns);  
			}    			
    		SetQuestionProperty(sAssessmentID,sQuestionID,"STUDENTANSWER",sStudentAns);  
   			SetQuestionProperty(sAssessmentID,sQuestionID,"LATENCY",qLatency);  
  			SetQuestionProperty(sAssessmentID,sQuestionID,"TIME",endTime);  
  			if ((""+sQType) != "undefined"){
	 		    SetQuestionProperty(sAssessmentID,sQuestionID,"QTYPE",sQType);
 			}
    	}  		  
	}  
	return sEvalResult;
}

// End Question High Level API


// Begin Supporting Question High level API

function ShowCorrectOnFinal(windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var persist = true;
	if (m_arrEvents[String(m_lEventID)].PERSIST != null) {
		if (m_arrEvents[String(m_lEventID)].PERSIST != "") {
			persist = m_arrEvents[String(m_lEventID)].PERSIST;
		}else{
			persist = m_bPersistData;
		}	
	}else{
		persist = m_bPersistData;
	}	
	if ((CP.convertNull(CP.m_arrEvents[String(m_lEventID)].STATE)== "F" || CP.convertNull(CP.m_arrEvents[String(m_lEventID)].STATE)== "C") && CP.convertNull(CP.m_arrEvents[String(m_lEventID)].CORRECTONFINAL).toLowerCase() == "true"){
		if (CP.convertNull(CP.m_arrEvents[String(m_lEventID)].FINALGROUP!="")){
			for (var i=0;i<CP.m_arrEvents[String(m_lEventID)].FINALGROUP.length;i++){
				var arrChk=windowtarget.document.getElementsByName(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i]);
				if (CP.convertNull(CP.m_arrEvents[String(m_lEventID)].STATE)== "C" && persist == true){ // if correct just send back the student answer for the correct answer
					var arrAns=CP.GetGroupStudentAns(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i],false,windowtarget);
				}else{
					var arrAns=CP.GetGroupCorrectAns(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i],false,windowtarget);
				}
				var oItem;
				for (oItem in arrAns){
					if (arrChk[oItem].type.toLowerCase() == "textarea"){
						arrChk[oItem].value=arrAns[oItem];
					}else{
						if (arrChk[oItem].type.toLowerCase() == "checkbox" || arrChk[oItem].type.toLowerCase() == "radio"){
							arrChk[oItem].checked=arrAns[oItem];
						}else if (arrChk[oItem].type == "" || arrChk[oItem].type.toLowerCase() == "text"){
							arrChk[oItem].value=arrAns[oItem];
						}
					}
				}
			}					
		}
	}
	for (var j=0;j<CP.m_arrEvents[String(m_lEventID)].FINALGROUP.length;j++){
		if (CP.convertNull(CP.m_arrEvents[String(m_lEventID)].STATE)== "F" || CP.convertNull(CP.m_arrEvents[String(m_lEventID)].STATE)== "C"){
			var arrChk=windowtarget.document.getElementsByName(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[j]);
			for (var i=0;i<arrChk.length;i++){
				arrChk[i].disabled = true;
			}
		}
	}	
	
}	
	

function ResultsFromEvaluateOption(sGroupName,windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var arrChk=windowtarget.document.getElementsByName(sGroupName);

	var sEvalResult = ""; 
	

	bIncomplete = true;
	for (var i=0; i<arrChk.length; i++) {
		if (arrChk[i].checked==true) {
			bIncomplete = false;
		}
	}
	if (bIncomplete) {
		sEvalResult = "Incomplete";
	}else{
		var aCorrectAns = GetGroupCorrectAns(sGroupName,"false",windowtarget);
		var aStudentAns = GetGroupStudentAns(sGroupName,"false",windowtarget);
		for (var i in aStudentAns){
			if (String(aStudentAns[i]).toLowerCase() == String(aCorrectAns[i]).toLowerCase()){
			}else{
				sEvalResult = "Incorrect";
			}
		}	
	}  
	sEvalResult=(sEvalResult=="")?"Correct":sEvalResult;
    
    if (sEvalResult=="Incomplete"){
        if (m_bIncompleteIncorrect==true){
            sEvalResult = "Incorrect";
        }
    }

	return sEvalResult;
}

function ResultsFromEvaluateEditbox(sGroupName,windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var arrEdt=windowtarget.document.getElementsByName(sGroupName);
	var sLength = 0;
	var sEvalResult = "";
	if (""+arrEdt.length == "undefined"){
		if (windowtarget.document.getElementsByName(sGroupName).name != ""){
			sLength = 1;
			if (arrEdt.value == ""){
		    	bIncomplete = true;
			}else{
		    	bIncomplete = false;
			}  
		}else{
			bIncomplete = true;
		}      
	}else{  
    	sLength = arrEdt.length;
		bIncomplete = true;
		for (var i=0; i<sLength; i++) {
			if (arrEdt[i].value!="") {
  				bIncomplete = false;
	  		}
		}
	}  
	if (bIncomplete) {
        if (m_bIncompleteIncorrect==true){
            return "Incorrect";
        }
		return "Incomplete";
	}else{
		var foid;
		for (var i=0;i<sLength;i++){
			foid = GetFrameObjectNameFromDOM(arrEdt[i]);
	    	var bMatchCase =  (convertNull(m_arrEvents[String(m_lEventID)].arrContent[foid].CASESENSATIVE.toLowerCase()) == "true")?true:false;
	    	var tmpAnswer = GetCorrectAns(foid);
	    	var studentAnswer = GetStudentAns(foid,windowtarget);
  			if (noCaseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer)){
  		    	if (sEvalResult != "Incorrect"){
  		    		sEvalResult = "Correct";
        		}else{
            		sEvalResult = "Partial";
            		break;
        		}  		        
  			}else if (caseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer)){ 
  		    	if (sEvalResult != "Incorrect"){
  		    		sEvalResult = "Correct";
        		}else{
            		sEvalResult = "Partial";
            		break;
        		}  		        
  			}else{
  				if (sEvalResult == "Correct"){
  		    		sEvalResult = "Partial";
				    break;
		  	    }else{
  				    sEvalResult = "Incorrect";
  				}  
  			}
		}
	}
	sEvalResult=(sEvalResult=="")?"Correct":sEvalResult;

	return sEvalResult;
}

function ShowCorrectBullets(sBulletPrefix, bShowAttemptedOnly, windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
		if (windowtarget == null){
			windowtarget = parent.content;
		}	
		if (CP.convertNull(CP.m_arrEvents[String(m_lEventID)].FINALGROUP!="")){
		for (var i=0;i<CP.m_arrEvents[String(m_lEventID)].FINALGROUP.length;i++){
			var arrChk=windowtarget.document.getElementsByName(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i]);
			var arrAns=CP.GetGroupCorrectAns(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i],false,windowtarget);
			var oItem;
			for (oItem in arrAns){
				var bullet = sBulletPrefix + "_" + arrChk[oItem].id.substring(arrChk[oItem].id.lastIndexOf("_")+1,arrChk[oItem].id.length);
				if (windowtarget.document.getElementById("div_" + bullet) != null){
					if (arrChk[oItem].type.toLowerCase() == "checkbox" || arrChk[oItem].type.toLowerCase() == "radio"){
						if (bShowAttemptedOnly==false){
							if (arrAns[oItem]==true){
								CP.SetVisibility(bullet,'visible',windowtarget);
							}	
						}else{
							if (GetEventData(m_lEventID,arrChk[oItem].id) == true){
								if (arrAns[oItem]== true){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}
							}	
						}	
					}else if (arrChk[oItem].type == "" || arrChk[oItem].type.toLowerCase() == "text" || arrChk[oItem].type.toLowerCase() == "textarea"){
						var bMatchCase =  (convertNull(m_arrEvents[String(m_lEventID)].arrContent[oItem].CASESENSATIVE.toLowerCase()) == "true")?true:false;
						if (bMatchCase){
							if (arrAns[oItem] == GetEventData(m_lEventID,arrChk[oItem].id)){
								if (bShowAttemptedOnly==false){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}else{
									if (arrChk[oItem] != ""){
										CP.SetVisibility(bullet,'visible',windowtarget);			
									}	
								}	
							}		
						}else{
							if (arrAns[oItem].toLowerCase() == GetEventData(m_lEventID,arrChk[oItem].id).toLowerCase()){
								if (bShowAttemptedOnly==false){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}else{
									if (arrChk[oItem] != ""){
										CP.SetVisibility(bullet,'visible',windowtarget);			
									}
								}	
							}
						}		
							
					}
				}
			}
		}					
	}
}	

function ShowIncorrectBullets(sBulletPrefix, bShowAttemptedOnly, windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
		if (windowtarget == null){
			windowtarget = parent.content;
		}
		if (CP.convertNull(CP.m_arrEvents[String(m_lEventID)].FINALGROUP!="")){
		for (var i=0;i<CP.m_arrEvents[String(m_lEventID)].FINALGROUP.length;i++){
			var arrChk=windowtarget.document.getElementsByName(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i]);
			var arrAns=CP.GetGroupCorrectAns(CP.m_arrEvents[String(m_lEventID)].FINALGROUP[i],false,windowtarget);
			var oItem;
			for (oItem in arrAns){
				var bullet = sBulletPrefix + "_" + arrChk[oItem].id.substring(arrChk[oItem].id.lastIndexOf("_")+1,arrChk[oItem].id.length);
				if (windowtarget.document.getElementById("div_" + bullet) != null){
					if (arrChk[oItem].type.toLowerCase() == "checkbox" || arrChk[oItem].type.toLowerCase() == "radio"){
						if (bShowAttemptedOnly==false){
							if (arrAns[oItem]==false){
								CP.SetVisibility(bullet,'visible',windowtarget);
							}	
						}else{
							if (GetEventData(m_lEventID,arrChk[oItem].id) == true){
								if (arrAns[oItem]== false){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}
							}
						}	
					}else if (arrChk[oItem].type == "" || arrChk[oItem].type.toLowerCase() == "text" || arrChk[oItem].type.toLowerCase() == "textarea"){
						var bMatchCase =  (convertNull(m_arrEvents[String(m_lEventID)].arrContent[oItem].CASESENSATIVE.toLowerCase()) == "true")?true:false;
						if (bMatchCase){
							if (arrAns[oItem] != GetEventData(m_lEventID,arrChk[oItem].id)){
								if (bShowAttemptedOnly==false){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}else{
									if (arrChk[oItem] != ""){
										CP.SetVisibility(bullet,'visible',windowtarget);			
									}	
								}	
							}		
						}else{
							if (arrAns[oItem].toLowerCase() != GetEventData(m_lEventID,arrChk[oItem].id).toLowerCase()){
								if (bShowAttemptedOnly==false){
									CP.SetVisibility(bullet,'visible',windowtarget);			
								}else{
									if (arrChk[oItem] != ""){
										CP.SetVisibility(bullet,'visible',windowtarget);			
									}
								}	
							}
						}	
					}
				}
			}
		}					
	}
}	

function noCaseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (bMatchCase) return false;
	
	var arrAnswers = tmpAnswer.split("|");
	for (var i=0; i<arrAnswers.length; i++) {
		if (studentAnswer.toLowerCase() == arrAnswers[i].toLowerCase()) {
			return true
		}
	}	
		
	return false;
}

function caseAnswerCorrect(bMatchCase,studentAnswer,tmpAnswer) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (!bMatchCase) return false;
	
	var arrAnswers = tmpAnswer.split("|");
	for (var i=0; i<arrAnswers.length; i++) {
		if (studentAnswer == arrAnswers[i]) {
			return true
		}
	}	
		
	return false;
}


function ResultsFromEvaluateCheckBox(sGroupName,windowtarget,bPartiallyCorrect) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var bPartial = false;
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (bPartiallyCorrect == null) {
		bPartiallyCorrect = "false";
	}
	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	
	var sEvalResult = "";
	var sCorrectAns = "";
	var sStudentAns = "";
	var bAnyCorrect = false;
	bIncomplete = true;
	for (var i=0; i<arrChk.length; i++) {
		if (arrChk[i].checked==true) {
			bIncomplete = false;
		}
	}
	if (bIncomplete) {
	    if (m_bIncompleteIncorrect==true){
            sEvalResult = "Incorrect";
        }else{
		    sEvalResult = "Incomplete";
        }		    
	}else{
		var aCorrectAns = GetGroupCorrectAns(sGroupName,"false",windowtarget);
		var aStudentAns = GetGroupStudentAns(sGroupName,"false",windowtarget);
		for (var i in aStudentAns){
			if (String(aStudentAns[i]).toLowerCase() == String(aCorrectAns[i]).toLowerCase()){
				if (String(aCorrectAns[i]).toLowerCase()== "true"){
					bAnyCorrect	= true;
				}	
				if (sEvalResult=="Incorrect"||sEvalResult==""){
					bPartial = true;	
				}	
			}else{
				sEvalResult = "Incorrect";
			}
		}			
 	 			
	}  
	if (sEvalResult == "Incorrect" && bPartial == true){ 
		//if (String(bPartiallyCorrect.toLowerCase()) == "true"){
		if(bPartial == true) {
			if (bAnyCorrect	== true) {
				sEvalResult="Partial";
			}	
		}else{	
			sEvalResult="Incorrect";
		}
	}	
		
	sEvalResult=(sEvalResult=="")?"Correct":sEvalResult;

	return sEvalResult;
}

function GetQuestionProperty(sAssessID,sQuesID,sProp){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
  if (m_arrAssessments[sAssessID] == null){
      return "";
  }
  if (m_arrAssessments[sAssessID].arrQuestions[sQuesID] == null){
      return "";
  }
  return eval("m_arrAssessments[sAssessID].arrQuestions[sQuesID]." + sProp);

}

function SetQuestionProperty(sAssessID,sQuesID,sProp,sValue){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
  if (m_arrAssessments[sAssessID] == null){
      return;
  }
  if (m_arrAssessments[sAssessID].arrQuestions[sQuesID] == null){
      return;
  }	
  sValue = replaceAll(sValue,"'","\\'");
  eval("m_arrAssessments[sAssessID].arrQuestions[sQuesID]." + sProp + "='" + sValue + "'");
}


function CalculateLatency(){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var endTime = new Date();
	return formatTime(parseInt((endTime.getTime() - m_lEventTimeBegin.getTime())/1000));
}

function JumpToOptionFrame(sGroupName,windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var fNum = GetOptionFrameNumber(sGroupName,windowtarget);
	if (fNum != null) {
		if (fNum != 0){  
			GotoFrame(fNum);
		}    
	}	
}  

function GetNumOfTries(sEventID){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var lEventID = GetEventRefNumFromName(sEventID);
	return convertNull(m_arrEvents[String(lEventID)].NUMOFTRIES);
}

function GetQuestionID(sEventID){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var lEventID = GetEventRefNumFromName(sEventID);
	if (m_arrEvents[String(lEventID)] == null){
		return "";
	}	
	var sQuestionID = convertNull(m_arrEvents[String(lEventID)].QUESTIONID);
	return sQuestionID.substring(sQuestionID.indexOf("- ")+2,sQuestionID.length);
}

function GetAssessmentID(sEventID){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var lEventID = GetEventRefNumFromName(sEventID);
	if (m_arrEvents[String(lEventID)] == null){
		return "";
	}	
	var sAssessmentID = convertNull(m_arrEvents[String(lEventID)].QUESTIONID);
	return sAssessmentID.substring(0,sAssessmentID.indexOf(" -"));
}

function GetQuestionType(sEventID){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	var lEventID = GetEventRefNumFromName(sEventID);
	return convertNull(m_arrEvents[String(lEventID)].QTYPE);
}			

function GetCorrectAns(sObjName){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	return convertNull(m_arrEvents[String(m_lEventID)].arrAnswers[sObjName]);
}

function GetStudentAns(sObjName, windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	var sObj = windowtarget.document.getElementById(sObjName);
	var sStudentAns = "";
	if (sObj.tagName.toLowerCase() == "textarea"){
		sStudentAns = sObj.value;
	}else{
		if (sObj.type.toLowerCase() == "checkbox" || sObj.type.toLowerCase() == "radio"){
			sStudentAns = sObj.checked;
		}else if (sObj.type == "" || sObj.type.toLowerCase() == "text"){
			sStudentAns  = sObj.value;
		}
	}
	return sStudentAns;
}

function GetGroupCorrectAns(sGroupName,bAsString,windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (bAsString == null) {
		bAsString = "false";
	}
	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	var aCorrectAns = new Array();
	var sCorrectAns = "";
	for (var i=0;i<arrChk.length;i++){
		foid = GetFrameObjectNameFromDOM(arrChk[i]);
		var isCorrect = convertNull(m_arrEvents[String(m_lEventID)].arrAnswers[foid]);
		if (isCorrect.toLowerCase() == "true"){
			isCorrect = true;
		}else if(isCorrect.toLowerCase() == "false"){
			isCorrect = false;
		}		 
		aCorrectAns[foid] = isCorrect;
		sCorrectAns = sCorrectAns + "|" + isCorrect;
	}
	if (String(bAsString).toLowerCase() == "true"){
		if (sCorrectAns.charAt(0) == "|"){
			sCorrectAns = sCorrectAns.substring(1,sCorrectAns.length);
		}
		return sCorrectAns;
	}	
	return aCorrectAns;
}	


function GetGroupStudentAns(sGroupName,bAsString,windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	if (bAsString == null) {
		bAsString = "false";
	}
	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	var aStudentAns = new Array();
	var sStudentAns = "";
	for (var i=0;i<arrChk.length;i++){
		foid = GetFrameObjectNameFromDOM(arrChk[i]);
		if (arrChk[i].tagName.toLowerCase() == "textarea"){
			aStudentAns[foid] = arrChk[i].value;
			sStudentAns = sStudentAns + "|" + arrChk[i].value;
		}else{
			if (arrChk[i].type.toLowerCase() == "checkbox" || arrChk[i].type.toLowerCase() == "radio"){
				aStudentAns[foid] = arrChk[i].checked;
				sStudentAns = sStudentAns + "|" + arrChk[i].checked;
			}else if (arrChk[i].type == "" || arrChk[i].type.toLowerCase() == "text"){
				aStudentAns[foid] = arrChk[i].value;
				sStudentAns = sStudentAns + "|" + arrChk[i].value;
			}
		}	
	}
	if (String(bAsString).toLowerCase() == "true"){
		if (sStudentAns.charAt(0) == "|"){
			sStudentAns = sStudentAns.substring(1,sStudentAns.length);
		}
		return sStudentAns;
	}	
	
	return aStudentAns;
	
}	

function GetAttemptsAtQuestion(){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	return m_nNumTries;
}	

function IsChecked(sContentName,windowtarget) {
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}
	return windowtarget.document.getElementById(sContentName).checked;
}

function GetOptionFrameNumber(sGroupName,windowtarget){
	m_sErrorFile = "CP2/question.js";    // For Error Handling
	if (windowtarget == null) {
		windowtarget = parent.content;
	}

	var arrChk=windowtarget.document.getElementsByName(sGroupName);
	var foid;
	for (var i=0; i<arrChk.length; i++) {
		foid = GetFrameObjectNameFromDOM(arrChk[i]);
		if (arrChk[i].checked==true) {
			if (convertNull(m_arrEvents[String(m_lEventID)].arrContent[foid].JUMPTO) != null){
				if (convertNull(m_arrEvents[String(m_lEventID)].arrContent[foid].JUMPTO) != ""){
					return convertNull(m_arrEvents[String(m_lEventID)].arrContent[foid].JUMPTO);		  
				}  
			}  
		}
	}			

	return;
}

function StartQTimer(nTime,sFunction){
		m_nQMaxTimeout = nTime;
    m_nQTimeoutID = setInterval("QTimer('" + sFunction + "')",1000);
}

function QTimer(sFunction){
		if(m_bInitial == true) {
			m_bInitial = false;
      clearInterval(m_nQTimeoutID);    
      m_nQTimeoutID = null;
      ReloadEvent();			
		}
	
	  m_nQTimeoutTime--;
    //window.status = m_nQTimeoutTime;

    if (m_nQTimeoutTime <= 0){
      clearInterval(m_nQTimeoutID);    
      m_nQTimeoutID = null;
      m_nNumTries = (Number(m_arrEvents[m_lEventID].NUMOFTRIES) + 1)
      m_bIncompleteIncorrect = true;
      eval(sFunction);
      return;
    }
}

function GetTimeRemaining(sObjectID,windowtarget){
    if (m_nQTimeoutID != null){
        m_nQTimeoutViewID = setInterval("CP.TimeRemaining('" + sObjectID + "'," + windowtarget + ")",100);
    }
    return "";
}

function TimeRemaining(sObjectID,targetwindow){
    if (m_nQTimeoutID != null){
        CP.SetText(sObjectID,m_nQTimeoutTime,targetwindow);
    }else{
        clearInterval(m_nQTimeoutViewID);
    }    
}


// End Supporting Question High level API
